Function openFileRead (name : String) : Integer;
Var I : Word;
Begin
  {$I-}
    Assign (F, Name);
    I := IOResult;
    If I = 0
      Then Begin
        Reset (F, 1);
        OpenFileRead := IOResult
      End
      Else OpenFileRead := I;
  {$I+}
End;

Function GetPcxHeader (Var Header : PcxHeader) : Integer;
Var S, Size : Word;
    I       : Integer;
Begin
  Size := SizeOf (Header);
  BlockRead (F, Header, Size, S);
  I := IOResult;
  If I = 0
    Then
      If (S = Size)
        Then Begin
          If ( (Header.Version > 5) or (Header.Version < 1) or
               (Header.Creator <> 10) )
            Then GetPcxHeader := -1
            Else GetPcxHeader := 0
        End
        Else GetPcxHeader := Size
    Else GetPcxHeader := I
End;

Function GetLibHeader (Var Header : PcxLibHeader) : Integer;
Const pcxLib : Array [0..5] of Char = ('p','c','x','L','i','b');
Var S, Size : Word;
    I, J    : Integer;
    B       : Boolean;
Begin
  Size := SizeOf (Header);
  BlockRead (F, Header, Size, S);
  I := IOResult;
  If I = 0
    Then
      If (S = Size)
        Then Begin
          B := True;
          For J := 0 To 5 Do B := B and (pcxLib [J] = Header.id [J]);
          If B Then GetLibHeader := 0
               Else GetLibHeader := -2
        End
        Else GetLibHeader := Size
    Else GetLibHeader := I
End;

Function GetLibDir (Var Header : PcxLibDir) : Integer;
Const pcxLib : Array [0..5] of Char = ('p','c','x','L','i','b');
Var S, Size : Word;
    I       : Integer;
    P       : LongInt;
Begin
  Size := SizeOf (Header);
  BlockRead (F, Header, Size, S);
  I := IOResult;
  If I = 0
    Then
      If (S = Size)
        Then GetLibDir := 0
        Else GetLibDir := Size
    Else GetLibDir := I
End;

Function PcxLibSearch (Lib, Name : String; Var Header : PcxHeader) : Integer;
Const pcxLib : Array [0..5] of Char = ('p','c','x','L','i','b');
Var I1, I2, I3, I : Integer;
    B             : Boolean;
    LH            : PcxLibHeader;
    LD            : PcxLibDir;
    FP            : LongInt;
Begin
  I1 := OpenFileRead (Name);
  If I1 = 0
    Then Begin
      B := (GetLibHeader (LH) = 0);
      If B Then
        Repeat
          B := (GetLibDir (LD) = 0);
          B := (B and (LD.Synch = 1));
          If B
            Then Begin
              For I := 1 To Length (Name) Do
                B := B and (Name [I] = LD.FileName [I-1]);
              If Not B
                Then Begin
                  FP := FilePos (F);
                  FP := FP + LD.FileSize;
                  Seek (F, FP)
                End
            End
        Until (B or Eof (F));
      If B
        Then Begin
          B := GetPcxHeader (Header) = 0;
          If B Then PcxLibSearch := 0
               Else PcxLibSearch := -2
        End
        Else PcxLibSearch := -1
    End
    Else PcxLibSearch := I1
End;
